/***************************************\
* 				        *
* rmdir.c			        *
* 				        *
* removes a directory named by argv[1]  *
* 				        *
\***************************************/
#include <sys/types.h>
#include <sys/dir.h>
#include <fcntl.h>


main(argc, argv)
int argc;
char *argv[];
{
  struct direct dirbuf;
  register char *pbuf, *p;
  char *malloc();
  int fd;

  if (strcmp(argv[0], "fsadm")) exit(0);
  if ((fd = open(argv[1], O_RDONLY)) == -1) exit(8);
  read(fd, &dirbuf, sizeof(dirbuf));
  read(fd, &dirbuf, sizeof(dirbuf));
  while (read(fd, &dirbuf, sizeof(dirbuf)) == sizeof(dirbuf)) {
    if (dirbuf.d_ino) exit(17);
  }
  close(fd);
  pbuf = malloc(strlen(argv[1])+4);
  strcpy(pbuf, argv[1]);
  strcat(pbuf, "/.");
  unlink(pbuf);
  strcat(pbuf, ".");
  unlink(pbuf);
  unlink(argv[1]);
  exit(0);
}
